#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>

// This function tries to give the process direct I/O port access.

int io_access(void) {
  int n;
  int gr[NGROUPS];

// We check first if we belong to group 0.

  n = NGROUPS;
  if (getgroups(&n, gr) != -1)
    while (n--)
      if (gr[n] == 0)
        return 0;  // OK, we are in group 0; we have access

// The process doesn't have direct I/O permission.  We'll try to obtain root
// privileges

  if (setuid(0) < 0)
    return -1;        // can't get root; no access

// OK, we are root now; we have access
  return 0;
}
